<template>
  <PDialog
    v-model:visible="isVisible"
    :header="t(`page.users.${mode}.title`)"
    modal
    dismissable-mask
    class="UserDialog"
  >
    <!-- Name -->
    <div class="UserDialog__Field">
      <label class="UserDialog__Label">
        <span class="UserDialog__LabelTxt">{{ t('resource.user.name') }}</span>
        <PInputText v-model.trim="userModel.name" autofocus />
        <ErrorWrapper :errors="errors['name']" />
      </label>
    </div>

    <!-- Email -->
    <div class="UserDialog__Field">
      <label class="UserDialog__Label">
        <span class="UserDialog__LabelTxt">{{ t('resource.user.email') }}</span>
        <PInputText id="email" v-model.trim="userModel.email" />
        <ErrorWrapper :errors="errors['email']" />
      </label>
    </div>

    <!-- Is user admin? -->
    <div class="UserDialog__Field">
      <label class="UserDialog__Label UserDialog__Label--inline">
        <span class="UserDialog__LabelTxt">{{
          t('resource.user.role_admin')
        }}</span>
        <PInputSwitch id="isAdmin" v-model="isAdmin" />
      </label>
    </div>

    <!-- Is user locked? -->
    <div class="UserDialog__Field">
      <label class="UserDialog__Label UserDialog__Label--inline">
        <span class="UserDialog__LabelTxt">{{
          t('resource.user.locked')
        }}</span>
        <PInputSwitch id="isLocked" v-model="isLocked" />
      </label>
    </div>

    <!-- Action buttons -->
    <template #footer>
      <!-- Cancel button -->
      <PButton
        :label="t('action.cancel')"
        icon="pi pi-times"
        class="p-button-text p-button-secondary"
        @click="isVisible = false"
      />
      <!-- Submit button -->
      <PButton
        :label="t(`page.users.${mode}.submit`)"
        icon="pi pi-check"
        class="p-button-text"
        :disabled="!isValid"
        :loading="submitting"
        @click="submitUser"
      />
      <!-- Delete button -->
      <PButton
        v-if="props.user && props.user?.id !== settings.user.id"
        :label="t('action.delete')"
        icon="pi pi-trash"
        class="p-button p-button-danger"
        @click="askForDeletion"
      />
    </template>
  </PDialog>

  <ConfirmDeleteDialog
    v-if="props.user?.id"
    v-model:visible="displayConfirmDelete"
    :redirect-url="{ ...ROUTES.USERS }"
    :uuid="props.user.id"
    resource-key="user"
    :resource-name="props.user.email"
    @deleted:resource="onUserDeleted($event)"
  />
</template>

<script lang="ts" setup>
import { computed, defineEmits, ref, toRefs } from 'vue'
import { useI18n } from 'vue-i18n'
import { User } from '@/api'
import { CurrentUser, useUser } from './useUser'
import ConfirmDeleteDialog from '@/components/resources/ConfirmDeleteDialog.vue'
import { ROUTES } from '@/plugins'
import { injectStrict } from '@/injectStrict'
import { SettingsKey } from '@/provided'

const props = defineProps<{
  user: CurrentUser
}>()

const settings = injectStrict(SettingsKey)

const emit = defineEmits<{
  (e: 'update:visible', value: boolean): void
  (e: 'cancel'): void
  (e: 'create:user', value: User): void
  (e: 'update:user', value: User): void
  (e: 'delete:user', value: User['id']): void
}>()

const { t } = useI18n()
const { user } = toRefs(props)

const displayConfirmDelete = ref<boolean>(false)
const {
  userModel,
  isValid,
  isAdmin,
  isLocked,
  submit,
  errors,
  mode,
  submitting,
  reset,
} = useUser(user, t)

/**
 * Hide user dialog & open confirm-delete-dialog
 */
function askForDeletion(): void {
  displayConfirmDelete.value = true
  emit('update:visible', false)
}

/**
 * Submit user data & emit events
 */
async function submitUser() {
  const user = await submit()

  if (user) {
    mode.value === 'update'
      ? emit('update:user', user)
      : emit('create:user', user)

    isVisible.value = false
  }
}

/**
 * Modal dialog visibility
 */
const isVisible = computed({
  get: () => props.user !== null,
  set: (value: boolean) => {
    if (!value) emit('cancel')
  },
})

function onUserDeleted(id: string) {
  emit('delete:user', id)
}
</script>

<style lang="scss" scoped>
@use '../../../style/variables' as v;

.UserDialog {
  &__Field {
    width: 100%;
    padding-top: v.$spacing-2;
  }

  &__Label {
    display: flex;
    flex-direction: column;

    &--inline {
      flex-direction: row;
      align-items: center;
      justify-content: space-between;
    }
  }

  &__LabelTxt {
    margin: 0 0 v.$spacing-4 0;
  }
}
</style>
